/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package courseworkapp;

import java.awt.BorderLayout;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Francis
 */
public class CourseForm extends javax.swing.JFrame {

    DefaultTableModel model;
    JTable courseworkTable;
    String[] coursework, fileContent, fileContent1;
    int index;

    /**
     * Creates new form CourseForm
     */
    public CourseForm() {
        initComponents();
        createCourseworkTable();

    }

    public void createCourseworkTable() {
        model = new DefaultTableModel();
        courseworkTable = new JTable(model) {
            public boolean isCellEditable(int row, int column) {
                if (column == 0) {
                    return false;//the 1st column is not editable  
                }
                return true;
            }

        };
        model.addColumn("No.");
        model.addColumn("Task");

        try {
            for (int i = 0; i < 2; i++) {
                model.addRow(new Object[]{"" + (i + 1) + "", ""});
            }

        } catch (Exception e) {
            JLabel label = new JLabel("<html><font color=RED>Error:" + e.getMessage() + " </font></html>");
            JOptionPane.showMessageDialog(this, label, "SERVER ERROR", JOptionPane.INFORMATION_MESSAGE);
        }
        tablePanel.setLayout(new BorderLayout());
        tablePanel.add(new JScrollPane(courseworkTable), BorderLayout.NORTH);
        courseworkTable.setRowSelectionAllowed(true);
        courseworkTable.setColumnSelectionAllowed(false);
        courseworkTable.setRowHeight(20);
        courseworkTable.setVisible(true);
    }

    public void createCourse() {   //--------------------- /*Create new directories*/-----------------------

        Path newDir0 = Paths.get("C:/Coursework Data/" + courseNameTextField.getText() + "/");
        Path newDir = Paths.get("C:/Coursework Data/");
        File file;
        file = new File("C:/Coursework Data/CoursesList.txt");
        boolean fileCreated = false;

        try {
            Files.createDirectory(newDir);
            fileCreated = file.createNewFile();

            if (fileCreated) {
                System.out.println("Created empty file: " + file.getPath());
            } else {
                System.out.println("Failed to create empty file: " + file.getPath());
            }
        } catch (IOException ex) {
            // JLabel label = new JLabel("<html><font color=RED>Error 11:" + ex.getMessage() + " </font></html>");
            //JOptionPane.showMessageDialog(null, "<html><font color=red>Error11:" + ex.getMessage() + "</font></html>");
        }
        try {
            // Files.createDirectory(newDir);
            Files.createDirectory(newDir0);
        } catch (IOException ex) {
            // JLabel label = new JLabel("<html><font color=RED>Error 11:" + ex.getMessage() + " </font></html>");
            JOptionPane.showMessageDialog(null, "<html><font color=red>Error11:" + ex.getMessage() + "</font></html>");

        }
        coursework = new String[courseworkTable.getRowCount()];
        for (int i = 0; i < courseworkTable.getRowCount(); i++) {
            coursework[i] = "Task" + (i + 1);
        }

        for (int i = 0; i < coursework.length; i++) {
            file = new File("C:/Coursework Data/" + courseNameTextField.getText() + "/" + coursework[i] + ".txt");
            // fileCreated = false;
            try {
                fileCreated = file.createNewFile();
            } catch (IOException ioe) {
                System.out.println("Error while creating empty file: " + ioe);
            }

            if (fileCreated) {
                System.out.println("Created empty file: " + file.getPath());
            } else {
                System.out.println("Failed to create empty file: " + file.getPath());
            }
        }
        writeFile();

    }

    public void writeFile() {
        //Writing to file
        try (FileWriter fw = new FileWriter("C:/Coursework Data/CoursesList.txt", true);
                BufferedWriter bw = new BufferedWriter(fw);
                PrintWriter out = new PrintWriter(bw)) {
            out.println(courseNameTextField.getText());

        } catch (IOException e) {
            //exception handling left as an exercise for the reader
        }
        for (int i = 0; i < coursework.length; i++) {
            try (FileWriter fw = new FileWriter("C:/Coursework Data/" + courseNameTextField.getText() + "/" + coursework[i] + ".txt", true);
                    BufferedWriter bw = new BufferedWriter(fw);
                    PrintWriter out = new PrintWriter(bw)) {
                out.println(courseworkTable.getValueAt(i, 1).toString());
                out.println();
            } catch (IOException e) {
                //exception handling left as an exercise for the reader
            }
        }
    }

    public void writeFile1() {
        //Writing to file
        Path newFile;
        newFile = Paths.get("C:/Coursework Data/CoursesList.txt");
        readCourses();
        try (BufferedWriter writer = Files.newBufferedWriter(
                newFile, Charset.defaultCharset())) {
            for (int p = 0; p < fileContent1.length; p++) {
                writer.append(fileContent1[p]);
                writer.newLine();
            }
            writer.append(courseNameTextField.getText().toUpperCase());
            writer.newLine();
            writer.flush();
        } catch (IOException ex) {
            System.out.println("Error writing to file");
        }

        for (int i = 0; i < coursework.length; i++) {
            newFile = Paths.get("C:/Coursework Data/" + courseNameTextField.getText() + "/" + coursework[i] + ".txt");
            try (BufferedWriter writer = Files.newBufferedWriter(
                    newFile, Charset.defaultCharset())) {
                writer.append(courseworkTable.getValueAt(i, 1).toString().toUpperCase());
                writer.newLine();
                writer.flush();
            } catch (IOException exception) {
                System.out.println("Error writing to file");
            }
        }
    }

    public void readFile() {
        //Reading from file
        fileContent = new String[30];
        for (int k = 0; k < coursework.length; k++) {
            Path newFile = Paths.get("C:/Coursework Data/" + courseNameTextField.getText() + "/" + coursework[k] + ".txt");
            try (BufferedReader reader = Files.newBufferedReader(
                    newFile, Charset.defaultCharset())) {
                String lineFromFile = "";

                index = 0;
                while ((lineFromFile = reader.readLine()) != null) {
                    fileContent[index] = lineFromFile;
                    index++;
                }
                reader.close();

            } catch (IOException e) {
                JOptionPane.showMessageDialog(null, "<html><font color=red>ReadError:" + e.getMessage() + "</font></html>");
                //System.out.println("Error while reading file");
            }
            System.out.println("Content of " + coursework[k] + ":\n" + fileContent[0]);
        }
    }

    public void readCourses() {
        //Reading from file        
        Path newFile = Paths.get("C:/Coursework Data/CoursesList.txt");
        String lineFromFile;
        try (BufferedReader reader = Files.newBufferedReader(
                newFile, Charset.defaultCharset())) {
            lineFromFile = "";
            int j = 0;
            while ((lineFromFile = reader.readLine()) != null) {
                j++;
            }

            fileContent1 = new String[j];

            lineFromFile = "";
            int i = 0;
            while ((lineFromFile = reader.readLine()) != null) {
                fileContent1[i] = lineFromFile;
                System.out.println(lineFromFile);
                i++;
            }
            reader.close();

        } catch (IOException e) {
            JOptionPane.showMessageDialog(null, "<html><font color=red>ReadError:" + e.getMessage() + "</font></html>");
            //System.out.println("Error while reading file");
        }
        //System.out.println("Content of " + coursework[k] + ":\n" + fileContent[0]);
        //}
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        courseNameTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        tablePanel = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));

        jLabel1.setText("Course Name:");

        courseNameTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                courseNameTextFieldActionPerformed(evt);
            }
        });

        jLabel2.setText("Coursework");

        javax.swing.GroupLayout tablePanelLayout = new javax.swing.GroupLayout(tablePanel);
        tablePanel.setLayout(tablePanelLayout);
        tablePanelLayout.setHorizontalGroup(
            tablePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        tablePanelLayout.setVerticalGroup(
            tablePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 285, Short.MAX_VALUE)
        );

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/courseworkapp/Images/SAVE.PNG"))); // NOI18N
        jButton1.setText("Save");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/courseworkapp/Images/Add.png"))); // NOI18N
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jLabel3.setText("Add coursework");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(29, 29, 29)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jButton1)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(jLabel2)
                        .addGroup(jPanel1Layout.createSequentialGroup()
                            .addComponent(jLabel1)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(courseNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 380, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addComponent(tablePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton2)
                    .addComponent(jLabel3))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(28, 28, 28)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(courseNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(tablePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addGap(18, 18, 18)
                        .addComponent(jButton2)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addContainerGap(19, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void courseNameTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_courseNameTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_courseNameTextFieldActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (courseNameTextField.getText().equals("")) {
            JOptionPane.showMessageDialog(this, "Enter the course name!");
        } else {
            int notNull = 0;
            for (int i = 0; i < courseworkTable.getRowCount(); i++) {
                if (courseworkTable.getValueAt(i, 1).toString().equals(null)
                        || courseworkTable.getValueAt(1, 1).toString().trim().length() == 0) {
                    notNull++;
                }
            }
            if (notNull != 0) {
                JOptionPane.showMessageDialog(this, "Fill all the tasks!");
            } else {
                createCourse();
                readFile();
            }
        }
// TODO add your handling code here:
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    model.addRow(new Object[]{"" + 
            (Integer.parseInt(courseworkTable.getValueAt(courseworkTable.getRowCount()-1, 0).toString())+1) + "", ""});
        
// TODO add your handling code here:
    }//GEN-LAST:event_jButton2ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(CourseForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(CourseForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(CourseForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(CourseForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new CourseForm().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField courseNameTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel tablePanel;
    // End of variables declaration//GEN-END:variables
}
