/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package courseworkapp;

import java.awt.Dimension;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.MatchResult;
import javax.swing.ImageIcon;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;

/**
 *
 * @author Francis
 */
public class MainForm extends javax.swing.JFrame {

    boolean search = false;

    /**
     * Creates new form mainForm
     */
    public MainForm() {
        initComponents();
        setDimension();
        windowClose();
        setWindowIcon();
        setcourses();
        disableSearch();
        jMenuItem1.hide();
        jMenuItem2.hide();
    }

    public void setDimension() {
        Dimension screensize = Toolkit.getDefaultToolkit().getScreenSize();
        //setLocation( (screensize.width - getWidth())/2, 
        //(screensize.height - getHeight())/2 );
        this.setSize(screensize);
        //  tabbedPane.setSize(screensize.width, screensize.height);
    }

    public void windowClose() {
        WindowListener wndCloser = new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                Object[] options = {"YES", "NO"};
                int option = JOptionPane.showOptionDialog(MainForm.this, "This will end your session.Do you really want to log out?", "LOG OUT",
                        JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE,
                        null, options, options[1]);
                if (option == JOptionPane.YES_OPTION) {
                    Object[] options1 = {"YES", "NO"};
                    int option1 = JOptionPane.showOptionDialog(MainForm.this, "It Is Recommended That You BackUp Your Database"
                            + "\n Before Loging Out.Do You Want To Perform The Backup?", "BACKUP DATABASE",
                            JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE,
                            null, options1, options1[0]);
                    if (option1 == JOptionPane.YES_OPTION) {
                        // DatabaseBackupForm.systemExit = true;
                        //DatabaseBackupForm.main(null);
                        MainForm.this.setVisible(false);
                    } else {
                        System.out.println("Thank You For Using Me.. :D");
                        System.exit(0);
                    }
                } else if (option == JOptionPane.NO_OPTION) {
                }
            }
        };

        addWindowListener(wndCloser);

    }

    public void setWindowIcon() {
        ImageIcon icon = new ImageIcon(getClass().getResource("/courseworkapp/Images/geography_2561.png"));
        Image temp = icon.getImage();
        this.setIconImage(temp);

    }

    public void setcourses() {
        //coursesMenu.add("COMP1752");
        //coursesMenu.add("COMP1753");
    }

    public void disableSearch() {
        searchTextField.setVisible(false);
        searchButton.setVisible(false);
        searchLabel.setVisible(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        tabbedPane = new javax.swing.JTabbedPane();
        scrollPane = new javax.swing.JScrollPane();
        jPanel1 = new javax.swing.JPanel();
        searchTextField = new javax.swing.JTextField();
        searchButton = new javax.swing.JButton();
        searchLabel = new javax.swing.JLabel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem5 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        tabbedPane.addTab("", scrollPane);

        jPanel1.setBackground(new java.awt.Color(204, 204, 255));

        searchButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/courseworkapp/Images/SEARCH.PNG"))); // NOI18N
        searchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchButtonActionPerformed(evt);
            }
        });

        searchLabel.setText("Type keyword to search notes: ");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(13, Short.MAX_VALUE)
                .addComponent(searchLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(searchTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 424, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(searchButton, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(searchTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(searchButton)
                .addComponent(searchLabel))
        );

        jMenu1.setText("Course");

        jMenuItem3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/courseworkapp/Images/Create.png"))); // NOI18N
        jMenuItem3.setText("Add");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem3);

        jMenuItem1.setText("Amend");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuItem2.setText("Delete");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem2);

        jMenuItem4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/courseworkapp/Images/PRINT.PNG"))); // NOI18N
        jMenuItem4.setText("Coursework Screen");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem4);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Note");

        jMenuItem5.setIcon(new javax.swing.ImageIcon(getClass().getResource("/courseworkapp/Images/Create.png"))); // NOI18N
        jMenuItem5.setText("New");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem5);

        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(tabbedPane)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(17, 17, 17)
                .addComponent(tabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        tabbedPane.addTab("COURSES", scrollPane);
        tabbedPane.setSelectedComponent(scrollPane);
        scrollPane.setViewportView(new CourseForm().getContentPane());
        search = false;
        if (search == true) {

        } else {
            disableSearch();
        }
        // TODO add your handling code here:
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
        tabbedPane.addTab("NOTES", scrollPane);
        tabbedPane.setSelectedComponent(scrollPane);
        scrollPane.setViewportView(new NotesForm().getContentPane());

        search = false;
        if (search == true) {

        } else {
            disableSearch();
        }
        // TODO add your handling code here:
    }//GEN-LAST:event_jMenuItem5ActionPerformed

    private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed

        tabbedPane.addTab("VIEW COURSEWORK", scrollPane);
        tabbedPane.setSelectedComponent(scrollPane);
        scrollPane.setViewportView(new ViewCoursework().getContentPane());

        search = true;
        if (search == true) {
            searchTextField.setVisible(true);
            searchButton.setVisible(true);
            searchLabel.setVisible(true);
        } else {
            disableSearch();
        }

// TODO add your handling code here:
    }//GEN-LAST:event_jMenuItem4ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        search = false;
        if (search == true) {

        } else {
            disableSearch();
        }        // TODO add your handling code here:
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        search = false;
        if (search == true) {

        } else {
            disableSearch();
        }        // TODO add your handling code here:
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void searchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchButtonActionPerformed
        if (ViewCoursework.notesTextArea.getText().contains(searchTextField.getText()) && searchTextField.getText().length() != 0) {
            //Writing to file
            Path newFile;
            newFile = Paths.get("./data.txt");
            try (BufferedWriter writer = Files.newBufferedWriter(
                    newFile, Charset.defaultCharset())) {
                writer.append(ViewCoursework.notesTextArea.getText());
                writer.newLine();
                writer.flush();
            } catch (IOException ex) {
                System.out.println("Error writing to file");
            }
              
              String text=ViewCoursework.notesTextArea.getText();
              ViewCoursework.notesTextArea.setText("");
            try {
                Scanner s = new Scanner(new File("data.txt"));
                while (null != s.findWithinHorizon("(?i)\\b" + searchTextField.getText() + "\\b", 0)) {
                    MatchResult mr = s.match();
                    System.out.printf("Word found: %s at index %d to %d.%n", mr.group(),
                            mr.start(), mr.end());
                    ViewCoursework.notesTextArea.setText(ViewCoursework.notesTextArea.getText()+"\n"
                            +text.substring(mr.start()-5, mr.end()+10));
                }
                s.close();
                
            } 
            catch (FileNotFoundException ex) {
                Logger.getLogger(MainForm.class.getName()).log(Level.SEVERE, null, ex);
            }
            // TODO add your handling code here:
        }
    }//GEN-LAST:event_searchButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MainForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MainForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MainForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MainForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainForm().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane scrollPane;
    private javax.swing.JButton searchButton;
    private javax.swing.JLabel searchLabel;
    private javax.swing.JTextField searchTextField;
    private javax.swing.JTabbedPane tabbedPane;
    // End of variables declaration//GEN-END:variables
}
