/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package courseworkapp;

import java.awt.BorderLayout;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Francis
 */
public class NotesForm extends javax.swing.JFrame {

    DefaultTableModel model;
    JTable courseworkTable;
    String[] coursework, fileContent;
    CourseForm obj = new CourseForm();
    String task;

    /**
     * Creates new form CourseForm
     */
    public NotesForm() {
        initComponents();
        readFile();
    }

    public void createCourseworkTable() {
        model = new DefaultTableModel();
        courseworkTable = new JTable(model) {
            public boolean isCellEditable(int row, int column) {
                if (column == 0) {
                    return false;//the 1st column is not editable  
                }
                return true;
            }

        };
        model.addColumn("No.");
        model.addColumn("Task");

        try {
            for (int i = 0; i < 20; i++) {
                model.addRow(new Object[]{"" + (i + 1) + "", ""});
            }

        } catch (Exception e) {
            JLabel label = new JLabel("<html><font color=RED>Error:" + e.getMessage() + " </font></html>");
            JOptionPane.showMessageDialog(this, label, "SERVER ERROR", JOptionPane.INFORMATION_MESSAGE);
        }
//.add(this)
        tablePanel.setLayout(new BorderLayout());
        tablePanel.add(new JScrollPane(courseworkTable), BorderLayout.NORTH);
        courseworkTable.setRowSelectionAllowed(true);
        courseworkTable.setColumnSelectionAllowed(false);
        courseworkTable.setRowHeight(20);
        courseworkTable.setVisible(true);
    }

    public void readFile() {
        //Reading from file
        Path newFile = Paths.get("C:/Coursework Data/CoursesList.txt");
        try (BufferedReader reader = Files.newBufferedReader(
                newFile, Charset.defaultCharset())) {
            String lineFromFile = "";

            int i = 0;
            while ((lineFromFile = reader.readLine()) != null) {
                if (i % 2 == 0) {
                    courseComboBox.addItem(lineFromFile);
                }
                i++;
            }
            reader.close();

        } catch (IOException e) {
            JOptionPane.showMessageDialog(null, "<html><font color=red>ReadError:" + e.getMessage() + "</font></html>");
            //System.out.println("Error while reading file");
        }
        //}
    }

    public void writeFile() {
        //Writing to file
        // for (int i = 0; i < coursework.length; i++) {
        try (FileWriter fw = new FileWriter("C:/Coursework Data/" + courseComboBox.getSelectedItem() + "/"
                + courseworkComboBox.getSelectedItem(), true);
                BufferedWriter bw = new BufferedWriter(fw);
                PrintWriter out = new PrintWriter(bw)) {
            out.println();
            out.println(notesTextArea.getText());
            out.println();
        } catch (IOException e) {
            //exception handling left as an exercise for the reader
        }
        //}
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        tablePanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        notesTextArea = new javax.swing.JTextArea();
        taskLabel = new javax.swing.JLabel();
        courseComboBox = new javax.swing.JComboBox();
        courseworkComboBox = new javax.swing.JComboBox();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));

        tablePanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Type notes here", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 3, 14), new java.awt.Color(51, 51, 255))); // NOI18N

        notesTextArea.setColumns(20);
        notesTextArea.setRows(5);
        jScrollPane1.setViewportView(notesTextArea);

        taskLabel.setText("Task");

        javax.swing.GroupLayout tablePanelLayout = new javax.swing.GroupLayout(tablePanel);
        tablePanel.setLayout(tablePanelLayout);
        tablePanelLayout.setHorizontalGroup(
            tablePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(tablePanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(tablePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 427, Short.MAX_VALUE)
                    .addGroup(tablePanelLayout.createSequentialGroup()
                        .addComponent(taskLabel)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        tablePanelLayout.setVerticalGroup(
            tablePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, tablePanelLayout.createSequentialGroup()
                .addComponent(taskLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 262, Short.MAX_VALUE)
                .addContainerGap())
        );

        courseComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Select course..." }));
        courseComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                courseComboBoxActionPerformed(evt);
            }
        });

        courseworkComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Select coursework..." }));
        courseworkComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                courseworkComboBoxActionPerformed(evt);
            }
        });

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/courseworkapp/Images/SAVE.PNG"))); // NOI18N
        jButton1.setText("Save");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(42, 42, 42)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jButton1)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(tablePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGroup(jPanel1Layout.createSequentialGroup()
                            .addComponent(courseComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(134, 134, 134)
                            .addComponent(courseworkComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap(59, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(28, 28, 28)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(courseComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(courseworkComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(tablePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void courseComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_courseComboBoxActionPerformed
        for (int i = 0; i < 10; i++) {
            courseworkComboBox.removeItem("Task" + (i + 1));
        }
        
        File folder = new File("C:/Coursework Data/" + courseComboBox.getSelectedItem());
        File[] listOfFiles = folder.listFiles();
        for (int i = 0; i < listOfFiles.length; i++) {
            if (listOfFiles[i].isFile()) {
                courseworkComboBox.addItem(listOfFiles[i].getName());
            } else if (listOfFiles[i].isDirectory()) {
                System.out.println("Directory " + listOfFiles[i].getName());
            }
        }        // TODO add your handling code here:
    }//GEN-LAST:event_courseComboBoxActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (courseComboBox.getSelectedIndex() == 0) {
            JOptionPane.showMessageDialog(this, "Select a course");
        } else if (courseworkComboBox.getSelectedIndex() == 0) {
            JOptionPane.showMessageDialog(this, "Select a coursework");
        } else {
            writeFile();
        }
        // TODO add your handling code here:
    }//GEN-LAST:event_jButton1ActionPerformed

    private void courseworkComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_courseworkComboBoxActionPerformed
        if (courseworkComboBox.getSelectedIndex() != 0) {

            //Reading from file
            Path newFile = Paths.get("C:/Coursework Data/" + courseComboBox.getSelectedItem() + "/"
                    + courseworkComboBox.getSelectedItem());
            try (BufferedReader reader = Files.newBufferedReader(
                    newFile, Charset.defaultCharset())) {
                String lineFromFile = "";

                int i = 0;
                while ((lineFromFile = reader.readLine()) != null) {
                    if (i == 0) {
                        task = lineFromFile;
                    }
                    i++;
                }
                reader.close();

            } catch (IOException e) {
                JOptionPane.showMessageDialog(null, "<html><font color=red>ReadError:" + e.getMessage() + "</font></html>");
                //System.out.println("Error while reading file");
            }

            taskLabel.setText(courseworkComboBox.getSelectedItem().toString() + ": " + task);
        }

// TODO add your handling code here:
    }//GEN-LAST:event_courseworkComboBoxActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(NotesForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(NotesForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(NotesForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(NotesForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new NotesForm().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox courseComboBox;
    private javax.swing.JComboBox courseworkComboBox;
    private javax.swing.JButton jButton1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea notesTextArea;
    private javax.swing.JPanel tablePanel;
    private javax.swing.JLabel taskLabel;
    // End of variables declaration//GEN-END:variables
}
